/*++

Copyright (c) 2011  Microsoft Corporation

Module Name:

    syminfo.c

--*/
#include "pch.h"
#include "WppStruct.h"

//
// typedefs usb.h should have included
//
typedef struct _URB_HEADER
URB_HEADER, *PURB_HEADER;

typedef struct _URB_SELECT_INTERFACE
URB_SELECT_INTERFACE, *PURB_SELECT_INTERFACE;

typedef struct _URB_SELECT_CONFIGURATION
URB_SELECT_CONFIGURATION, *PURB_SELECT_CONFIGURATION;

typedef struct _URB_GET_CURRENT_FRAME_NUMBER
URB_GET_CURRENT_FRAME_NUMBER, *PURB_GET_CURRENT_FRAME_NUMBER;

typedef struct _URB_BULK_OR_INTERRUPT_TRANSFER 
URB_BULK_OR_INTERRUPT_TRANSFER, *PURB_BULK_OR_INTERRUPT_TRANSFER;

typedef struct _URB_CONTROL_DESCRIPTOR_REQUEST
URB_CONTROL_DESCRIPTOR_REQUEST, *PURB_CONTROL_DESCRIPTOR_REQUEST;

typedef struct _URB_CONTROL_GET_STATUS_REQUEST
URB_CONTROL_GET_STATUS_REQUEST, *PURB_CONTROL_GET_STATUS_REQUEST;

typedef struct _URB_CONTROL_VENDOR_OR_CLASS_REQUEST
URB_CONTROL_VENDOR_OR_CLASS_REQUEST, *PURB_CONTROL_VENDOR_OR_CLASS_REQUEST;

typedef struct _URB_OS_FEATURE_DESCRIPTOR_REQUEST 
URB_OS_FEATURE_DESCRIPTOR_REQUEST, *PURB_OS_FEATURE_DESCRIPTOR_REQUEST;

typedef struct _URB_PIPE_REQUEST 
URB_PIPE_REQUEST, *PURB_PIPE_REQUEST;

typedef struct _URB_CONTROL_TRANSFER
URB_CONTROL_TRANSFER, *PURB_CONTROL_TRANSFER;

typedef struct _URB_CONTROL_TRANSFER_EX
URB_CONTROL_TRANSFER_EX, *PURB_CONTROL_TRANSFER_EX;

typedef struct _URB_CONTROL_GET_CONFIGURATION_REQUEST
URB_CONTROL_GET_CONFIGURATION_REQUEST, *PURB_CONTROL_GET_CONFIGURATION_REQUEST;

typedef struct _URB_CONTROL_FEATURE_REQUEST
URB_CONTROL_FEATURE_REQUEST, *PURB_CONTROL_FEATURE_REQUEST;

typedef struct _URB_CONTROL_GET_INTERFACE_REQUEST
URB_CONTROL_GET_INTERFACE_REQUEST, *PURB_CONTROL_GET_INTERFACE_REQUEST;

typedef struct _URB_ISOCH_TRANSFER
URB_ISOCH_TRANSFER, *PURB_ISOCH_TRANSFER;


#define DECLARE_TYPE(Name) Name _DECL_##Name

//
// Keep the list sorted
//
DECLARE_TYPE (ENDPOINT_TRANSFER_TYPE);
DECLARE_TYPE (LIST_ENTRY);
DECLARE_TYPE (RHPDO_CONTEXT);
DECLARE_TYPE (SM_ENGINE_CONTEXT);
DECLARE_TYPE (SM_ENGINE_EVENT);
DECLARE_TYPE (SM_ENGINE_STATE);
DECLARE_TYPE (SM_ENGINE_STATE_LOG);
DECLARE_TYPE (UCX_ENDPOINT_ALL_EVENT_CALLBACKS);
DECLARE_TYPE (UCX_IOCTL);
DECLARE_TYPE (UCX_USBDEVICE_EVENT_CALLBACKS);
DECLARE_TYPE (UCXCONTROLLER_PRIVCONTEXT);
DECLARE_TYPE (UCXENDPOINT_PRIVCONTEXT);
DECLARE_TYPE (UCXENDPOINT_TYPE);
DECLARE_TYPE (UCXROOTHUB_PRIVCONTEXT);
DECLARE_TYPE (UCXUSBDEVICE_PRIVCONTEXT);
DECLARE_TYPE (USBDI_HANDLE_DATA);
DECLARE_TYPE (USBD_ISO_PACKET_DESCRIPTOR);
DECLARE_TYPE (URB_BULK_OR_INTERRUPT_TRANSFER);
DECLARE_TYPE (URB_CONTROL_DESCRIPTOR_REQUEST);
DECLARE_TYPE (URB_CONTROL_GET_CONFIGURATION_REQUEST);
DECLARE_TYPE (URB_CONTROL_GET_INTERFACE_REQUEST);
DECLARE_TYPE (URB_CONTROL_GET_STATUS_REQUEST);
DECLARE_TYPE (URB_CONTROL_FEATURE_REQUEST);
DECLARE_TYPE (URB_CONTROL_TRANSFER_EX);
DECLARE_TYPE (URB_CONTROL_VENDOR_OR_CLASS_REQUEST);
DECLARE_TYPE (URB_HEADER);
DECLARE_TYPE (URB_ISOCH_TRANSFER);
DECLARE_TYPE (URB_OS_FEATURE_DESCRIPTOR_REQUEST);
DECLARE_TYPE (URB_PIPE_REQUEST);
DECLARE_TYPE (URB_SELECT_CONFIGURATION);
DECLARE_TYPE (URB_SELECT_INTERFACE);
DECLARE_TYPE (WDFDRIVER_UCX_CONTEXT);
DECLARE_TYPE (WPP_TRACE_CONTROL_BLOCK);

int __cdecl main() {
    return 0;
}
