//*****************************************************************************
//***                        THIS FILE IS GENERATED                        ****
//***                       DO NOT MODIFY THIS FILE !!!                    ****
//*****************************************************************************
//*****************************************************************************
//* File: D3D11ValueSets.cpp
//* 
//* Description: 
//*     Defines classes that implement common ValueSets and filters related to enums
//*
//*****************************************************************************

#include "pch.h"
#include "D3D11ValueSets.h"

BEGIN_NAMED_VALUES( D3D11_INPUT_CLASSIFICATION )
    NAMED_VALUE( _T( "VERTEX_DATA" ), D3D11_INPUT_PER_VERTEX_DATA )
    NAMED_VALUE( _T( "INSTANCE_DATA" ), D3D11_INPUT_PER_INSTANCE_DATA )
END_NAMED_VALUES( D3D11_INPUT_CLASSIFICATION )

BEGIN_NAMED_VALUES( D3D11_FILL_MODE )
    NAMED_VALUE( _T( "WIREFRAME" ), D3D11_FILL_WIREFRAME )
    NAMED_VALUE( _T( "SOLID" ), D3D11_FILL_SOLID )
END_NAMED_VALUES( D3D11_FILL_MODE )

BEGIN_NAMED_VALUES( D3D11_CULL_MODE )
    NAMED_VALUE( _T( "NONE" ), D3D11_CULL_NONE )
    NAMED_VALUE( _T( "FRONT" ), D3D11_CULL_FRONT )
    NAMED_VALUE( _T( "BACK" ), D3D11_CULL_BACK )
END_NAMED_VALUES( D3D11_CULL_MODE )

BEGIN_NAMED_VALUES( D3D11_RESOURCE_DIMENSION )
    NAMED_VALUE( _T( "UNKNOWN" ), D3D11_RESOURCE_DIMENSION_UNKNOWN )
    NAMED_VALUE( _T( "BUFFER" ), D3D11_RESOURCE_DIMENSION_BUFFER )
    NAMED_VALUE( _T( "TEXTURE1D" ), D3D11_RESOURCE_DIMENSION_TEXTURE1D )
    NAMED_VALUE( _T( "TEXTURE2D" ), D3D11_RESOURCE_DIMENSION_TEXTURE2D )
    NAMED_VALUE( _T( "TEXTURE3D" ), D3D11_RESOURCE_DIMENSION_TEXTURE3D )
END_NAMED_VALUES( D3D11_RESOURCE_DIMENSION )

BEGIN_NAMED_VALUES( D3D11_DSV_DIMENSION )
    NAMED_VALUE( _T( "UNKNOWN" ), D3D11_DSV_DIMENSION_UNKNOWN )
    NAMED_VALUE( _T( "TEXTURE1D" ), D3D11_DSV_DIMENSION_TEXTURE1D )
    NAMED_VALUE( _T( "TEXTURE1DARRAY" ), D3D11_DSV_DIMENSION_TEXTURE1DARRAY )
    NAMED_VALUE( _T( "TEXTURE2D" ), D3D11_DSV_DIMENSION_TEXTURE2D )
    NAMED_VALUE( _T( "TEXTURE2DARRAY" ), D3D11_DSV_DIMENSION_TEXTURE2DARRAY )
    NAMED_VALUE( _T( "TEXTURE2DMS" ), D3D11_DSV_DIMENSION_TEXTURE2DMS )
    NAMED_VALUE( _T( "TEXTURE2DMSARRAY" ), D3D11_DSV_DIMENSION_TEXTURE2DMSARRAY )
END_NAMED_VALUES( D3D11_DSV_DIMENSION )

BEGIN_NAMED_VALUES( D3D11_RTV_DIMENSION )
    NAMED_VALUE( _T( "UNKNOWN" ), D3D11_RTV_DIMENSION_UNKNOWN )
    NAMED_VALUE( _T( "BUFFER" ), D3D11_RTV_DIMENSION_BUFFER )
    NAMED_VALUE( _T( "TEXTURE1D" ), D3D11_RTV_DIMENSION_TEXTURE1D )
    NAMED_VALUE( _T( "TEXTURE1DARRAY" ), D3D11_RTV_DIMENSION_TEXTURE1DARRAY )
    NAMED_VALUE( _T( "TEXTURE2D" ), D3D11_RTV_DIMENSION_TEXTURE2D )
    NAMED_VALUE( _T( "TEXTURE2DARRAY" ), D3D11_RTV_DIMENSION_TEXTURE2DARRAY )
    NAMED_VALUE( _T( "TEXTURE2DMS" ), D3D11_RTV_DIMENSION_TEXTURE2DMS )
    NAMED_VALUE( _T( "TEXTURE2DMSARRAY" ), D3D11_RTV_DIMENSION_TEXTURE2DMSARRAY )
    NAMED_VALUE( _T( "TEXTURE3D" ), D3D11_RTV_DIMENSION_TEXTURE3D )
END_NAMED_VALUES( D3D11_RTV_DIMENSION )

BEGIN_NAMED_VALUES( D3D11_USAGE )
    NAMED_VALUE( _T( "DEFAULT" ), D3D11_USAGE_DEFAULT )
    NAMED_VALUE( _T( "IMMUTABLE" ), D3D11_USAGE_IMMUTABLE )
    NAMED_VALUE( _T( "DYNAMIC" ), D3D11_USAGE_DYNAMIC )
    NAMED_VALUE( _T( "STAGING" ), D3D11_USAGE_STAGING )
END_NAMED_VALUES( D3D11_USAGE )

//////////////////////////////////////////////////////////////////////////
// Implementation of CD3D11BindFlagValueSet
//////////////////////////////////////////////////////////////////////////

CD3D11BindFlagValueSet::CD3D11BindFlagValueSet( CFilterHandleCommonSource< D3D11_BIND_FLAG > filter )
{
	D3D11_BIND_FLAG D3D11BindFlag;
	
	if( filter.IsValid() )
		filter->SetSource( &D3D11BindFlag );
	
	int count = CD3D11BindFlagInfoMap::GetD3D11BindFlagInfoTableSize();

	for( int i = 0; i < count; i++ )
	{
		D3D11BindFlag = CD3D11BindFlagInfoMap::GetD3D11BindFlagInfo( i ).D3D11BindFlag;
		
		if( !filter.IsValid() || filter->Match() )
			AddValue( D3D11BindFlag );
	}
}


//////////////////////////////////////////////////////////////////////////
// Implementation of CD3D11CpuAccessFlagValueSet
//////////////////////////////////////////////////////////////////////////

CD3D11CpuAccessFlagValueSet::CD3D11CpuAccessFlagValueSet( CFilterHandleCommonSource< D3D11_CPU_ACCESS_FLAG > filter )
{
	D3D11_CPU_ACCESS_FLAG D3D11CpuAccessFlag;
	
	if( filter.IsValid() )
		filter->SetSource( &D3D11CpuAccessFlag );
	
	int count = CD3D11CpuAccessFlagInfoMap::GetD3D11CpuAccessFlagInfoTableSize();

	for( int i = 0; i < count; i++ )
	{
		D3D11CpuAccessFlag = CD3D11CpuAccessFlagInfoMap::GetD3D11CpuAccessFlagInfo( i ).D3D11CpuAccessFlag;
		
		if( !filter.IsValid() || filter->Match() )
			AddValue( D3D11CpuAccessFlag );
	}
}


//////////////////////////////////////////////////////////////////////////
// Implementation of CD3D11ResourceMiscFlagValueSet
//////////////////////////////////////////////////////////////////////////

CD3D11ResourceMiscFlagValueSet::CD3D11ResourceMiscFlagValueSet( CFilterHandleCommonSource< D3D11_RESOURCE_MISC_FLAG > filter )
{
	D3D11_RESOURCE_MISC_FLAG D3D11ResourceMiscFlag;
	
	if( filter.IsValid() )
		filter->SetSource( &D3D11ResourceMiscFlag );
	
	int count = CD3D11ResourceMiscFlagInfoMap::GetD3D11ResourceMiscFlagInfoTableSize();

	for( int i = 0; i < count; i++ )
	{
		D3D11ResourceMiscFlag = CD3D11ResourceMiscFlagInfoMap::GetD3D11ResourceMiscFlagInfo( i ).D3D11ResourceMiscFlag;
		
		if( !filter.IsValid() || filter->Match() )
			AddValue( D3D11ResourceMiscFlag );
	}
}


BEGIN_NAMED_VALUES( D3D11_MAP )
    NAMED_VALUE( _T( "READ" ), D3D11_MAP_READ )
    NAMED_VALUE( _T( "WRITE" ), D3D11_MAP_WRITE )
    NAMED_VALUE( _T( "READ_WRITE" ), D3D11_MAP_READ_WRITE )
    NAMED_VALUE( _T( "WRITE_DISCARD" ), D3D11_MAP_WRITE_DISCARD )
    NAMED_VALUE( _T( "WRITE_NO_OVERWRITE" ), D3D11_MAP_WRITE_NO_OVERWRITE )
END_NAMED_VALUES( D3D11_MAP )

//////////////////////////////////////////////////////////////////////////
// Implementation of CD3D11MapFlagValueSet
//////////////////////////////////////////////////////////////////////////

CD3D11MapFlagValueSet::CD3D11MapFlagValueSet( CFilterHandleCommonSource< D3D11_MAP_FLAG > filter )
{
	D3D11_MAP_FLAG D3D11MapFlag;
	
	if( filter.IsValid() )
		filter->SetSource( &D3D11MapFlag );
	
	int count = CD3D11MapFlagInfoMap::GetD3D11MapFlagInfoTableSize();

	for( int i = 0; i < count; i++ )
	{
		D3D11MapFlag = CD3D11MapFlagInfoMap::GetD3D11MapFlagInfo( i ).D3D11MapFlag;
		
		if( !filter.IsValid() || filter->Match() )
			AddValue( D3D11MapFlag );
	}
}


//////////////////////////////////////////////////////////////////////////
// Implementation of CD3D11RaiseFlagValueSet
//////////////////////////////////////////////////////////////////////////

CD3D11RaiseFlagValueSet::CD3D11RaiseFlagValueSet( CFilterHandleCommonSource< D3D11_RAISE_FLAG > filter )
{
	D3D11_RAISE_FLAG D3D11RaiseFlag;
	
	if( filter.IsValid() )
		filter->SetSource( &D3D11RaiseFlag );
	
	int count = CD3D11RaiseFlagInfoMap::GetD3D11RaiseFlagInfoTableSize();

	for( int i = 0; i < count; i++ )
	{
		D3D11RaiseFlag = CD3D11RaiseFlagInfoMap::GetD3D11RaiseFlagInfo( i ).D3D11RaiseFlag;
		
		if( !filter.IsValid() || filter->Match() )
			AddValue( D3D11RaiseFlag );
	}
}


//////////////////////////////////////////////////////////////////////////
// Implementation of CD3D11ClearFlagValueSet
//////////////////////////////////////////////////////////////////////////

CD3D11ClearFlagValueSet::CD3D11ClearFlagValueSet( CFilterHandleCommonSource< D3D11_CLEAR_FLAG > filter )
{
	D3D11_CLEAR_FLAG D3D11ClearFlag;
	
	if( filter.IsValid() )
		filter->SetSource( &D3D11ClearFlag );
	
	int count = CD3D11ClearFlagInfoMap::GetD3D11ClearFlagInfoTableSize();

	for( int i = 0; i < count; i++ )
	{
		D3D11ClearFlag = CD3D11ClearFlagInfoMap::GetD3D11ClearFlagInfo( i ).D3D11ClearFlag;
		
		if( !filter.IsValid() || filter->Match() )
			AddValue( D3D11ClearFlag );
	}
}


BEGIN_NAMED_VALUES( D3D11_COMPARISON_FUNC )
    NAMED_VALUE( _T( "NEVER" ), D3D11_COMPARISON_NEVER )
    NAMED_VALUE( _T( "LESS" ), D3D11_COMPARISON_LESS )
    NAMED_VALUE( _T( "EQUAL" ), D3D11_COMPARISON_EQUAL )
    NAMED_VALUE( _T( "LESS_EQUAL" ), D3D11_COMPARISON_LESS_EQUAL )
    NAMED_VALUE( _T( "GREATER" ), D3D11_COMPARISON_GREATER )
    NAMED_VALUE( _T( "NOT_EQUAL" ), D3D11_COMPARISON_NOT_EQUAL )
    NAMED_VALUE( _T( "GREATER_EQUAL" ), D3D11_COMPARISON_GREATER_EQUAL )
    NAMED_VALUE( _T( "ALWAYS" ), D3D11_COMPARISON_ALWAYS )
END_NAMED_VALUES( D3D11_COMPARISON_FUNC )

BEGIN_NAMED_VALUES( D3D11_DEPTH_WRITE_MASK )
    NAMED_VALUE( _T( "ZERO" ), D3D11_DEPTH_WRITE_MASK_ZERO )
    NAMED_VALUE( _T( "ALL" ), D3D11_DEPTH_WRITE_MASK_ALL )
END_NAMED_VALUES( D3D11_DEPTH_WRITE_MASK )

BEGIN_NAMED_VALUES( D3D11_STENCIL_OP )
    NAMED_VALUE( _T( "KEEP" ), D3D11_STENCIL_OP_KEEP )
    NAMED_VALUE( _T( "ZERO" ), D3D11_STENCIL_OP_ZERO )
    NAMED_VALUE( _T( "REPLACE" ), D3D11_STENCIL_OP_REPLACE )
    NAMED_VALUE( _T( "INCR_SAT" ), D3D11_STENCIL_OP_INCR_SAT )
    NAMED_VALUE( _T( "DECR_SAT" ), D3D11_STENCIL_OP_DECR_SAT )
    NAMED_VALUE( _T( "INVERT" ), D3D11_STENCIL_OP_INVERT )
    NAMED_VALUE( _T( "INCR" ), D3D11_STENCIL_OP_INCR )
    NAMED_VALUE( _T( "DECR" ), D3D11_STENCIL_OP_DECR )
END_NAMED_VALUES( D3D11_STENCIL_OP )

BEGIN_NAMED_VALUES( D3D11_BLEND )
    NAMED_VALUE( _T( "ZERO" ), D3D11_BLEND_ZERO )
    NAMED_VALUE( _T( "ONE" ), D3D11_BLEND_ONE )
    NAMED_VALUE( _T( "SRC_COLOR" ), D3D11_BLEND_SRC_COLOR )
    NAMED_VALUE( _T( "INV_SRC_COLOR" ), D3D11_BLEND_INV_SRC_COLOR )
    NAMED_VALUE( _T( "SRC_ALPHA" ), D3D11_BLEND_SRC_ALPHA )
    NAMED_VALUE( _T( "INV_SRC_ALPHA" ), D3D11_BLEND_INV_SRC_ALPHA )
    NAMED_VALUE( _T( "DEST_ALPHA" ), D3D11_BLEND_DEST_ALPHA )
    NAMED_VALUE( _T( "INV_DEST_ALPHA" ), D3D11_BLEND_INV_DEST_ALPHA )
    NAMED_VALUE( _T( "DEST_COLOR" ), D3D11_BLEND_DEST_COLOR )
    NAMED_VALUE( _T( "INV_DEST_COLOR" ), D3D11_BLEND_INV_DEST_COLOR )
    NAMED_VALUE( _T( "SRC_ALPHA_SAT" ), D3D11_BLEND_SRC_ALPHA_SAT )
    NAMED_VALUE( _T( "BLEND_FACTOR" ), D3D11_BLEND_BLEND_FACTOR )
    NAMED_VALUE( _T( "INV_BLEND_FACTOR" ), D3D11_BLEND_INV_BLEND_FACTOR )
    NAMED_VALUE( _T( "SRC1_COLOR" ), D3D11_BLEND_SRC1_COLOR )
    NAMED_VALUE( _T( "INV_SRC1_COLOR" ), D3D11_BLEND_INV_SRC1_COLOR )
    NAMED_VALUE( _T( "SRC1_ALPHA" ), D3D11_BLEND_SRC1_ALPHA )
    NAMED_VALUE( _T( "INV_SRC1_ALPHA" ), D3D11_BLEND_INV_SRC1_ALPHA )
END_NAMED_VALUES( D3D11_BLEND )

BEGIN_NAMED_VALUES( D3D11_BLEND_OP )
    NAMED_VALUE( _T( "ADD" ), D3D11_BLEND_OP_ADD )
    NAMED_VALUE( _T( "SUBTRACT" ), D3D11_BLEND_OP_SUBTRACT )
    NAMED_VALUE( _T( "REV_SUBTRACT" ), D3D11_BLEND_OP_REV_SUBTRACT )
    NAMED_VALUE( _T( "MIN" ), D3D11_BLEND_OP_MIN )
    NAMED_VALUE( _T( "MAX" ), D3D11_BLEND_OP_MAX )
END_NAMED_VALUES( D3D11_BLEND_OP )

BEGIN_NAMED_VALUES( D3D11_COLOR_WRITE_ENABLE )
    NAMED_VALUE( _T( "RED" ), D3D11_COLOR_WRITE_ENABLE_RED )
    NAMED_VALUE( _T( "GREEN" ), D3D11_COLOR_WRITE_ENABLE_GREEN )
    NAMED_VALUE( _T( "BLUE" ), D3D11_COLOR_WRITE_ENABLE_BLUE )
    NAMED_VALUE( _T( "ALPHA" ), D3D11_COLOR_WRITE_ENABLE_ALPHA )
    NAMED_VALUE( _T( "ALL" ), D3D11_COLOR_WRITE_ENABLE_ALL )
END_NAMED_VALUES( D3D11_COLOR_WRITE_ENABLE )

BEGIN_NAMED_VALUES( D3D11_TEXTURECUBE_FACE )
    NAMED_VALUE( _T( "POSITIVE_X" ), D3D11_TEXTURECUBE_FACE_POSITIVE_X )
    NAMED_VALUE( _T( "NEGATIVE_X" ), D3D11_TEXTURECUBE_FACE_NEGATIVE_X )
    NAMED_VALUE( _T( "POSITIVE_Y" ), D3D11_TEXTURECUBE_FACE_POSITIVE_Y )
    NAMED_VALUE( _T( "NEGATIVE_Y" ), D3D11_TEXTURECUBE_FACE_NEGATIVE_Y )
    NAMED_VALUE( _T( "POSITIVE_Z" ), D3D11_TEXTURECUBE_FACE_POSITIVE_Z )
    NAMED_VALUE( _T( "NEGATIVE_Z" ), D3D11_TEXTURECUBE_FACE_NEGATIVE_Z )
END_NAMED_VALUES( D3D11_TEXTURECUBE_FACE )

BEGIN_NAMED_VALUES( D3D11_FILTER )
    NAMED_VALUE( _T( "MIN_MAG_MIP_POINT" ), D3D11_FILTER_MIN_MAG_MIP_POINT )
    NAMED_VALUE( _T( "MIN_MAG_POINT_MIP_LINEAR" ), D3D11_FILTER_MIN_MAG_POINT_MIP_LINEAR )
    NAMED_VALUE( _T( "MIN_POINT_MAG_LINEAR_MIP_POINT" ), D3D11_FILTER_MIN_POINT_MAG_LINEAR_MIP_POINT )
    NAMED_VALUE( _T( "MIN_POINT_MAG_MIP_LINEAR" ), D3D11_FILTER_MIN_POINT_MAG_MIP_LINEAR )
    NAMED_VALUE( _T( "MIN_LINEAR_MAG_MIP_POINT" ), D3D11_FILTER_MIN_LINEAR_MAG_MIP_POINT )
    NAMED_VALUE( _T( "MIN_LINEAR_MAG_POINT_MIP_LINEAR" ), D3D11_FILTER_MIN_LINEAR_MAG_POINT_MIP_LINEAR )
    NAMED_VALUE( _T( "MIN_MAG_LINEAR_MIP_POINT" ), D3D11_FILTER_MIN_MAG_LINEAR_MIP_POINT )
    NAMED_VALUE( _T( "MIN_MAG_MIP_LINEAR" ), D3D11_FILTER_MIN_MAG_MIP_LINEAR )
    NAMED_VALUE( _T( "ANISOTROPIC" ), D3D11_FILTER_ANISOTROPIC )
    NAMED_VALUE( _T( "COMPARISON_MIN_MAG_MIP_POINT" ), D3D11_FILTER_COMPARISON_MIN_MAG_MIP_POINT )
    NAMED_VALUE( _T( "COMPARISON_MIN_MAG_POINT_MIP_LINEAR" ), D3D11_FILTER_COMPARISON_MIN_MAG_POINT_MIP_LINEAR )
    NAMED_VALUE( _T( "COMPARISON_MIN_POINT_MAG_LINEAR_MIP_POINT" ), D3D11_FILTER_COMPARISON_MIN_POINT_MAG_LINEAR_MIP_POINT )
    NAMED_VALUE( _T( "COMPARISON_MIN_POINT_MAG_MIP_LINEAR" ), D3D11_FILTER_COMPARISON_MIN_POINT_MAG_MIP_LINEAR )
    NAMED_VALUE( _T( "COMPARISON_MIN_LINEAR_MAG_MIP_POINT" ), D3D11_FILTER_COMPARISON_MIN_LINEAR_MAG_MIP_POINT )
    NAMED_VALUE( _T( "COMPARISON_MIN_LINEAR_MAG_POINT_MIP_LINEAR" ), D3D11_FILTER_COMPARISON_MIN_LINEAR_MAG_POINT_MIP_LINEAR )
    NAMED_VALUE( _T( "COMPARISON_MIN_MAG_LINEAR_MIP_POINT" ), D3D11_FILTER_COMPARISON_MIN_MAG_LINEAR_MIP_POINT )
    NAMED_VALUE( _T( "COMPARISON_MIN_MAG_MIP_LINEAR" ), D3D11_FILTER_COMPARISON_MIN_MAG_MIP_LINEAR )
    NAMED_VALUE( _T( "COMPARISON_ANISOTROPIC" ), D3D11_FILTER_COMPARISON_ANISOTROPIC )
END_NAMED_VALUES( D3D11_FILTER )

BEGIN_NAMED_VALUES( D3D11_FILTER_TYPE )
    NAMED_VALUE( _T( "POINT" ), D3D11_FILTER_TYPE_POINT )
    NAMED_VALUE( _T( "LINEAR" ), D3D11_FILTER_TYPE_LINEAR )
END_NAMED_VALUES( D3D11_FILTER_TYPE )

BEGIN_NAMED_VALUES( D3D11_TEXTURE_ADDRESS_MODE )
    NAMED_VALUE( _T( "WRAP" ), D3D11_TEXTURE_ADDRESS_WRAP )
    NAMED_VALUE( _T( "MIRROR" ), D3D11_TEXTURE_ADDRESS_MIRROR )
    NAMED_VALUE( _T( "CLAMP" ), D3D11_TEXTURE_ADDRESS_CLAMP )
    NAMED_VALUE( _T( "BORDER" ), D3D11_TEXTURE_ADDRESS_BORDER )
    NAMED_VALUE( _T( "MIRROR_ONCE" ), D3D11_TEXTURE_ADDRESS_MIRROR_ONCE )
END_NAMED_VALUES( D3D11_TEXTURE_ADDRESS_MODE )

BEGIN_NAMED_VALUES( D3D11_FORMAT_SUPPORT )
    NAMED_VALUE( _T( "BUFFER" ), D3D11_FORMAT_SUPPORT_BUFFER )
    NAMED_VALUE( _T( "IA_VERTEX_BUFFER" ), D3D11_FORMAT_SUPPORT_IA_VERTEX_BUFFER )
    NAMED_VALUE( _T( "IA_INDEX_BUFFER" ), D3D11_FORMAT_SUPPORT_IA_INDEX_BUFFER )
    NAMED_VALUE( _T( "SO_BUFFER" ), D3D11_FORMAT_SUPPORT_SO_BUFFER )
    NAMED_VALUE( _T( "TEXTURE1D" ), D3D11_FORMAT_SUPPORT_TEXTURE1D )
    NAMED_VALUE( _T( "TEXTURE2D" ), D3D11_FORMAT_SUPPORT_TEXTURE2D )
    NAMED_VALUE( _T( "TEXTURE3D" ), D3D11_FORMAT_SUPPORT_TEXTURE3D )
    NAMED_VALUE( _T( "TEXTURECUBE" ), D3D11_FORMAT_SUPPORT_TEXTURECUBE )
    NAMED_VALUE( _T( "SHADER_LOAD" ), D3D11_FORMAT_SUPPORT_SHADER_LOAD )
    NAMED_VALUE( _T( "SHADER_SAMPLE" ), D3D11_FORMAT_SUPPORT_SHADER_SAMPLE )
    NAMED_VALUE( _T( "SHADER_SAMPLE_COMPARISON" ), D3D11_FORMAT_SUPPORT_SHADER_SAMPLE_COMPARISON )
    NAMED_VALUE( _T( "SHADER_SAMPLE_MONO_TEXT" ), D3D11_FORMAT_SUPPORT_SHADER_SAMPLE_MONO_TEXT )
    NAMED_VALUE( _T( "MIP" ), D3D11_FORMAT_SUPPORT_MIP )
    NAMED_VALUE( _T( "MIP_AUTOGEN" ), D3D11_FORMAT_SUPPORT_MIP_AUTOGEN )
    NAMED_VALUE( _T( "RENDER_TARGET" ), D3D11_FORMAT_SUPPORT_RENDER_TARGET )
    NAMED_VALUE( _T( "BLENDABLE" ), D3D11_FORMAT_SUPPORT_BLENDABLE )
    NAMED_VALUE( _T( "DEPTH_STENCIL" ), D3D11_FORMAT_SUPPORT_DEPTH_STENCIL )
    NAMED_VALUE( _T( "CPU_LOCKABLE" ), D3D11_FORMAT_SUPPORT_CPU_LOCKABLE )
    NAMED_VALUE( _T( "MULTISAMPLE_RESOLVE" ), D3D11_FORMAT_SUPPORT_MULTISAMPLE_RESOLVE )
    NAMED_VALUE( _T( "DISPLAY" ), D3D11_FORMAT_SUPPORT_DISPLAY )
    NAMED_VALUE( _T( "CAST_WITHIN_BIT_LAYOUT" ), D3D11_FORMAT_SUPPORT_CAST_WITHIN_BIT_LAYOUT )
    NAMED_VALUE( _T( "MULTISAMPLE_RENDERTARGET" ), D3D11_FORMAT_SUPPORT_MULTISAMPLE_RENDERTARGET )
    NAMED_VALUE( _T( "MULTISAMPLE_LOAD" ), D3D11_FORMAT_SUPPORT_MULTISAMPLE_LOAD )
    NAMED_VALUE( _T( "SHADER_GATHER" ), D3D11_FORMAT_SUPPORT_SHADER_GATHER )
    NAMED_VALUE( _T( "BACK_BUFFER_CAST" ), D3D11_FORMAT_SUPPORT_BACK_BUFFER_CAST )
END_NAMED_VALUES( D3D11_FORMAT_SUPPORT )

BEGIN_NAMED_VALUES( D3D11_ASYNC_GETDATA_FLAG )
    NAMED_VALUE( _T( "ASYNC_GETDATA_DONOTFLUSH" ), D3D11_ASYNC_GETDATA_DONOTFLUSH )
END_NAMED_VALUES( D3D11_ASYNC_GETDATA_FLAG )

BEGIN_NAMED_VALUES( D3D11_QUERY )
    NAMED_VALUE( _T( "EVENT" ), D3D11_QUERY_EVENT )
    NAMED_VALUE( _T( "OCCLUSION" ), D3D11_QUERY_OCCLUSION )
    NAMED_VALUE( _T( "TIMESTAMP" ), D3D11_QUERY_TIMESTAMP )
    NAMED_VALUE( _T( "TIMESTAMP_DISJOINT" ), D3D11_QUERY_TIMESTAMP_DISJOINT )
    NAMED_VALUE( _T( "PIPELINE_STATISTICS" ), D3D11_QUERY_PIPELINE_STATISTICS )
    NAMED_VALUE( _T( "OCCLUSION_PREDICATE" ), D3D11_QUERY_OCCLUSION_PREDICATE )
    NAMED_VALUE( _T( "SO_STATISTICS" ), D3D11_QUERY_SO_STATISTICS )
    NAMED_VALUE( _T( "SO_OVERFLOW_PREDICATE" ), D3D11_QUERY_SO_OVERFLOW_PREDICATE )
END_NAMED_VALUES( D3D11_QUERY )

BEGIN_NAMED_VALUES( D3D11_QUERY_MISC_FLAG )
    NAMED_VALUE( _T( "QUERY_MISC_PREDICATEHINT" ), D3D11_QUERY_MISC_PREDICATEHINT )
END_NAMED_VALUES( D3D11_QUERY_MISC_FLAG )

BEGIN_NAMED_VALUES( D3D11_COUNTER )
    NAMED_VALUE( _T( "COUNTER_DEVICE_DEPENDENT_0" ), D3D11_COUNTER_DEVICE_DEPENDENT_0 )
END_NAMED_VALUES( D3D11_COUNTER )

BEGIN_NAMED_VALUES( D3D11_COUNTER_TYPE )
    NAMED_VALUE( _T( "FLOAT32" ), D3D11_COUNTER_TYPE_FLOAT32 )
    NAMED_VALUE( _T( "UINT16" ), D3D11_COUNTER_TYPE_UINT16 )
    NAMED_VALUE( _T( "UINT32" ), D3D11_COUNTER_TYPE_UINT32 )
    NAMED_VALUE( _T( "UINT64" ), D3D11_COUNTER_TYPE_UINT64 )
END_NAMED_VALUES( D3D11_COUNTER_TYPE )

BEGIN_NAMED_VALUES( D3D11_STANDARD_MULTISAMPLE_QUALITY_LEVELS )
    NAMED_VALUE( _T( "STANDARD_MULTISAMPLE_PATTERN" ), D3D11_STANDARD_MULTISAMPLE_PATTERN )
    NAMED_VALUE( _T( "CENTER_MULTISAMPLE_PATTERN" ), D3D11_CENTER_MULTISAMPLE_PATTERN )
END_NAMED_VALUES( D3D11_STANDARD_MULTISAMPLE_QUALITY_LEVELS )

BEGIN_NAMED_VALUES( D3D11_CREATE_DEVICE_FLAG )
    NAMED_VALUE( _T( "SINGLETHREADED" ), D3D11_CREATE_DEVICE_SINGLETHREADED )
    NAMED_VALUE( _T( "DEBUG" ), D3D11_CREATE_DEVICE_DEBUG )
    NAMED_VALUE( _T( "SWITCH_TO_REF" ), D3D11_CREATE_DEVICE_SWITCH_TO_REF )
    NAMED_VALUE( _T( "PREVENT_INTERNAL_THREADING_OPTIMIZATIONS" ), D3D11_CREATE_DEVICE_PREVENT_INTERNAL_THREADING_OPTIMIZATIONS )
    NAMED_VALUE( _T( "BGRA_SUPPORT" ), D3D11_CREATE_DEVICE_BGRA_SUPPORT )
END_NAMED_VALUES( D3D11_CREATE_DEVICE_FLAG )

BEGIN_NAMED_VALUES( D3D11_MESSAGE_CATEGORY )
    NAMED_VALUE( _T( "APPLICATION_DEFINED" ), D3D11_MESSAGE_CATEGORY_APPLICATION_DEFINED )
    NAMED_VALUE( _T( "MISCELLANEOUS" ), D3D11_MESSAGE_CATEGORY_MISCELLANEOUS )
    NAMED_VALUE( _T( "INITIALIZATION" ), D3D11_MESSAGE_CATEGORY_INITIALIZATION )
    NAMED_VALUE( _T( "CLEANUP" ), D3D11_MESSAGE_CATEGORY_CLEANUP )
    NAMED_VALUE( _T( "COMPILATION" ), D3D11_MESSAGE_CATEGORY_COMPILATION )
    NAMED_VALUE( _T( "STATE_CREATION" ), D3D11_MESSAGE_CATEGORY_STATE_CREATION )
    NAMED_VALUE( _T( "STATE_SETTING" ), D3D11_MESSAGE_CATEGORY_STATE_SETTING )
    NAMED_VALUE( _T( "STATE_GETTING" ), D3D11_MESSAGE_CATEGORY_STATE_GETTING )
    NAMED_VALUE( _T( "RESOURCE_MANIPULATION" ), D3D11_MESSAGE_CATEGORY_RESOURCE_MANIPULATION )
    NAMED_VALUE( _T( "EXECUTION" ), D3D11_MESSAGE_CATEGORY_EXECUTION )
END_NAMED_VALUES( D3D11_MESSAGE_CATEGORY )

BEGIN_NAMED_VALUES( D3D11_MESSAGE_SEVERITY )
    NAMED_VALUE( _T( "CORRUPTION" ), D3D11_MESSAGE_SEVERITY_CORRUPTION )
    NAMED_VALUE( _T( "ERROR" ), D3D11_MESSAGE_SEVERITY_ERROR )
    NAMED_VALUE( _T( "WARNING" ), D3D11_MESSAGE_SEVERITY_WARNING )
    NAMED_VALUE( _T( "INFO" ), D3D11_MESSAGE_SEVERITY_INFO )
END_NAMED_VALUES( D3D11_MESSAGE_SEVERITY )

