RECOMPILED_INCLUDE = stdafx.h
#PRECOMPILED_CXX = 1

SOURCES = \
    Main.cpp \
    kitContent.kml \
    DefaultResource.rc # Autogenerated file name + version for Device Guard whitelisting effort


TARGETLIBS = $(TARGETLIBS) \
    $(SDK_LIB_PATH)\kernel32.lib \
    $(SDK_LIB_PATH)\shlwapi.lib \
    $(SDK_LIB_PATH)\advapi32.lib \
    $(SDKTOOLS_LIB_PATH)\WexTest\Cue\Wex.Common.lib \
    $(SDKTOOLS_LIB_PATH)\WexTest\Cue\Wex.Logger.lib \
    $(SDK_LIB_PATH)\Ntdll.lib \
    $(SDKTOOLS_LIB_PATH)\WexTest\Cue\Te.Common.lib \
    $(WINDOWS_LIB_PATH)\D3DCompiler_TEST.lib \
    $(SDK_LIB_PATH)\d3d11.lib \
    $(SDK_LIB_PATH)\dxgi.lib \
    $(SDK_LIB_PATH)\d2d1.lib \
    $(WINDOWS_LIB_PATH)\d3dx9.lib \
    $(WINDOWS_TST_COMMON)\etwPostProcessing\XperfHelper\lib\$O\XperfHelper.lib \
    $(WINDOWS_TST_COMMON)\etwPostProcessing\DxEtwHelper\lib\$O\DxEtwHelper.lib \
    $(WINDOWS_TST_COMMON)\etwConsumers\etwLib\lib\unicode\$O\etwLibConsumer.lib \
    $(PUBLIC_ROOT)\internal\windows\lib\*\unicode\etw.lib \
    $(BASE_VID_TST_OBJ_ROOT)\tests\schtaef\renderlib\lib\$O\Workload.lib \

PASS_INDEPENDENT_BINPLACE= \
    .\addremove_perfdx.ps1 \

# Autogenerated. Sets file name for Device Guard whitelisting effort, used in RC.exe.
C_DEFINES=$(C_DEFINES) -D___TARGETNAME="""$(TARGETNAME).$(TARGETTYPE)"""
MUI_VERIFY_NO_LOC_RESOURCE=1
#include "Test_Include.fx"

int Test_Count = 117;

string TestInfo
<
	string TestType = "VS";
>
= "vs_1_1_inst_dp3";

VS_CRITERIA VS_001_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_001_Desc = "vs_1_1 : dp3 source reg combination v0, r0 is allowed";
string VS_001 = 
	"vs_1_1 "
	"dcl_texcoord v0 "
	"mov r0, c0 "
	"dp3 r0, v0, r0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_002_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_002_Desc = "vs_1_1 : dp3 source reg combination v0, c0 is allowed";
string VS_002 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_003_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_003_Desc = "vs_1_1 : dp3 source reg combination r0, v0 is allowed";
string VS_003 = 
	"vs_1_1 "
	"dcl_texcoord v0 "
	"mov r0, c0 "
	"dp3 r0, r0, v0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_004_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_004_Desc = "vs_1_1 : dp3 source reg combination r0, r1 is allowed";
string VS_004 = 
	"vs_1_1 "
	"mov r0, c0 "
	"mov r1, c0 "
	"dp3 r0, r0, r1 "
	"mov oPos, c0 ";

VS_CRITERIA VS_005_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_005_Desc = "vs_1_1 : dp3 source reg combination r0, c0 is allowed";
string VS_005 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"mov r0, c0 "
	"dp3 r0, r0, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_006_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_006_Desc = "vs_1_1 : dp3 source reg combination c0, v0 is allowed";
string VS_006 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, c0, v0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_007_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_007_Desc = "vs_1_1 : dp3 source reg combination c0, r0 is allowed";
string VS_007 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"mov r0, c0 "
	"dp3 r0, c0, r0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_008_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_008_Desc = "vs_1_1 : dp3 source reg combination -v0, -c0 is allowed";
string VS_008 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, -v0, -c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_009_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_009_Desc = "vs_1_1 : dp3 source reg combination -v0, c0 is allowed";
string VS_009 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, -v0, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_010_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_010_Desc = "vs_1_1 : dp3 source reg combination v0, -c0 is allowed";
string VS_010 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0, -c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_011_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_011_Desc = "vs_1_1 : dp3 source reg combination v0, c0 is allowed";
string VS_011 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_012_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_012_Desc = "vs_1_1 : dp3 source reg combination v0.x, c0 is allowed";
string VS_012 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.x, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_013_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_013_Desc = "vs_1_1 : dp3 source reg combination v0.y, c0 is allowed";
string VS_013 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.y, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_014_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_014_Desc = "vs_1_1 : dp3 source reg combination v0.z, c0 is allowed";
string VS_014 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.z, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_015_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_015_Desc = "vs_1_1 : dp3 source reg combination v0.w, c0 is allowed";
string VS_015 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.w, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_016_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_016_Desc = "vs_1_1 : dp3 source reg combination v0.yzxw, c0 is allowed";
string VS_016 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.yzxw, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_017_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_017_Desc = "vs_1_1 : dp3 source reg combination v0.zxyw, c0 is allowed";
string VS_017 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.zxyw, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_018_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_018_Desc = "vs_1_1 : dp3 source reg combination v0.wzyx, c0 is allowed";
string VS_018 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.wzyx, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_019_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_019_Desc = "vs_1_1 : dp3 source reg combination v0.wyxz, c0 is allowed";
string VS_019 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.wyxz, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_020_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_020_Desc = "vs_1_1 : dp3 source reg combination v0.xzyw, c0 is allowed";
string VS_020 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.xzyw, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_021_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_021_Desc = "vs_1_1 : dp3 source reg combination v0.xywz, c0 is allowed";
string VS_021 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.xywz, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_022_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_022_Desc = "vs_1_1 : dp3 source reg combination v0.zyx, c0 is allowed";
string VS_022 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.zyx, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_023_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_023_Desc = "vs_1_1 : dp3 source reg combination v0.xzy, c0 is allowed";
string VS_023 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.xzy, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_024_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_024_Desc = "vs_1_1 : dp3 source reg combination v0.ywx, c0 is allowed";
string VS_024 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.ywx, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_025_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_025_Desc = "vs_1_1 : dp3 source reg combination v0.yx, c0 is allowed";
string VS_025 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.yx, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_026_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_026_Desc = "vs_1_1 : dp3 source reg combination v0.wz, c0 is allowed";
string VS_026 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.wz, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_027_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_027_Desc = "vs_1_1 : dp3 source reg combination v0.zy, c0 is allowed";
string VS_027 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0.zy, c0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_028_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_028_Desc = "vs_1_1 : dp3 source reg combination v0, c0.x is allowed";
string VS_028 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_texcoord v0 "
	"dp3 r0, v0, c0.x "
	"mov oPos, c0 ";

VS_CRITERIA VS_029_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_029_Desc = "vs_1_1 : dp3 source reg combination v0, c0.y is allowed";
string VS_029 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_tangent v0 "
	"dp3 r0, v0, c0.y "
	"mov oPos, c0 ";

VS_CRITERIA VS_030_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_030_Desc = "vs_1_1 : dp3 source reg combination v0, c0.z is allowed";
string VS_030 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_tangent v0 "
	"dp3 r0, v0, c0.z "
	"mov oPos, c0 ";

VS_CRITERIA VS_031_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_031_Desc = "vs_1_1 : dp3 source reg combination v0, c0.w is allowed";
string VS_031 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_tangent v0 "
	"dp3 r0, v0, c0.w "
	"mov oPos, c0 ";

VS_CRITERIA VS_032_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_032_Desc = "vs_1_1 : dp3 source reg combination v0, c0.yzxw is allowed";
string VS_032 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_tangent v0 "
	"dp3 r0, v0, c0.yzxw "
	"mov oPos, c0 ";

VS_CRITERIA VS_033_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_033_Desc = "vs_1_1 : dp3 source reg combination v0, c0.zxyw is allowed";
string VS_033 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_tangent v0 "
	"dp3 r0, v0, c0.zxyw "
	"mov oPos, c0 ";

VS_CRITERIA VS_034_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_034_Desc = "vs_1_1 : dp3 source reg combination v0, c0.wzyx is allowed";
string VS_034 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_tangent v0 "
	"dp3 r0, v0, c0.wzyx "
	"mov oPos, c0 ";

VS_CRITERIA VS_035_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_035_Desc = "vs_1_1 : dp3 source reg combination v0, c0.wyxz is allowed";
string VS_035 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_tangent v0 "
	"dp3 r0, v0, c0.wyxz "
	"mov oPos, c0 ";

VS_CRITERIA VS_036_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_036_Desc = "vs_1_1 : dp3 source reg combination v0, c0.xzyw is allowed";
string VS_036 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_tangent v0 "
	"dp3 r0, v0, c0.xzyw "
	"mov oPos, c0 ";

VS_CRITERIA VS_037_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_037_Desc = "vs_1_1 : dp3 source reg combination v0, c0.xywz is allowed";
string VS_037 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_tangent v0 "
	"dp3 r0, v0, c0.xywz "
	"mov oPos, c0 ";

VS_CRITERIA VS_038_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_038_Desc = "vs_1_1 : dp3 source reg combination v0, c0.zyx is allowed";
string VS_038 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_tangent v0 "
	"dp3 r0, v0, c0.zyx "
	"mov oPos, c0 ";

VS_CRITERIA VS_039_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_039_Desc = "vs_1_1 : dp3 source reg combination v0, c0.xzy is allowed";
string VS_039 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_tangent v0 "
	"dp3 r0, v0, c0.xzy "
	"mov oPos, c0 ";

VS_CRITERIA VS_040_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_040_Desc = "vs_1_1 : dp3 source reg combination v0, c0.ywx is allowed";
string VS_040 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_tangent v0 "
	"dp3 r0, v0, c0.ywx "
	"mov oPos, c0 ";

VS_CRITERIA VS_041_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_041_Desc = "vs_1_1 : dp3 source reg combination v0, c0.yx is allowed";
string VS_041 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_tangent v0 "
	"dp3 r0, v0, c0.yx "
	"mov oPos, c0 ";

VS_CRITERIA VS_042_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_042_Desc = "vs_1_1 : dp3 source reg combination v0, c0.wz is allowed";
string VS_042 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_tangent v0 "
	"dp3 r0, v0, c0.wz "
	"mov oPos, c0 ";

VS_CRITERIA VS_043_Criteria = { true, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_043_Desc = "vs_1_1 : dp3 source reg combination v0, c0.zy is allowed";
string VS_043 = 
	"vs_1_1 "
	"def c0, 1, 1, 1, 1 "
	"dcl_tangent v0 "
	"dp3 r0, v0, c0.zy "
	"mov oPos, c0 ";

VS_CRITERIA VS_044_Criteria = { false, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_044_Desc = "vs_1_1 : dp3 source reg combination v0, v1 is NOT allowed";
string VS_044 = 
	"vs_1_1 "
	"dcl_tangent v0 "
	"dcl_depth v1 "
	"dp3 r0, v0, v1 "
	"mov oPos, c0 ";

VS_CRITERIA VS_045_Criteria = { false, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_045_Desc = "vs_1_1 : dp3 source reg combination c0, c1 is NOT allowed";
string VS_045 = 
	"vs_1_1 "
	"def c1, 1, 1, 1, 1 "
	"def c0, 1, 1, 1, 1 "
	"dp3 r0, c0, c1 "
	"mov oPos, c0 ";

VS_CRITERIA VS_046_Criteria = { false, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_046_Desc = "vs_1_1 : dp3 source reg combination a0, a0 is NOT allowed";
string VS_046 = 
	"vs_1_1 "
	"mov a0.x, c0.x "
	"dp3 r0, a0, a0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_047_Criteria = { false, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_047_Desc = "vs_1_1 : dp3 source reg combination a0, oPos is NOT allowed";
string VS_047 = 
	"vs_1_1 "
	"mov a0.x, c0.x "
	"dp3 r0, a0, oPos "
	"mov oPos, c0 ";

VS_CRITERIA VS_048_Criteria = { false, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_048_Desc = "vs_1_1 : dp3 source reg combination a0, oFog is NOT allowed";
string VS_048 = 
	"vs_1_1 "
	"mov a0.x, c0.x "
	"dp3 r0, a0, oFog "
	"mov oPos, c0 ";

VS_CRITERIA VS_049_Criteria = { false, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_049_Desc = "vs_1_1 : dp3 source reg combination a0, oPts is NOT allowed";
string VS_049 = 
	"vs_1_1 "
	"texcoord ts "
	"mov a0.x, c0.x "
	"dp3 r0, a0, oPts "
	"mov oPos, c0 ";

VS_CRITERIA VS_050_Criteria = { false, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_050_Desc = "vs_1_1 : dp3 source reg combination a0, oD0 is NOT allowed";
string VS_050 = 
	"vs_1_1 "
	"mov a0.x, c0.x "
	"dp3 r0, a0, oD0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_051_Criteria = { false, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_051_Desc = "vs_1_1 : dp3 source reg combination a0, oT0 is NOT allowed";
string VS_051 = 
	"vs_1_1 "
	"mov a0.x, c0.x "
	"dp3 r0, a0, oT0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_052_Criteria = { false, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_052_Desc = "vs_1_1 : dp3 source reg combination oPos, a0 is NOT allowed";
string VS_052 = 
	"vs_1_1 "
	"mov a0.x, c0.x "
	"dp3 r0, oPos, a0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_053_Criteria = { false, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_053_Desc = "vs_1_1 : dp3 source reg combination oPos, oPos is NOT allowed";
string VS_053 = 
	"vs_1_1 "
	"dp3 r0, oPos, oPos "
	"mov oPos, c0 ";

VS_CRITERIA VS_054_Criteria = { false, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_054_Desc = "vs_1_1 : dp3 source reg combination oPos, oFog is NOT allowed";
string VS_054 = 
	"vs_1_1 "
	"dp3 r0, oPos, oFog "
	"mov oPos, c0 ";

VS_CRITERIA VS_055_Criteria = { false, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_055_Desc = "vs_1_1 : dp3 source reg combination oPos, oPts is NOT allowed";
string VS_055 = 
	"vs_1_1 "
	"texcoord ts "
	"dp3 r0, oPos, oPts "
	"mov oPos, c0 ";

VS_CRITERIA VS_056_Criteria = { false, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_056_Desc = "vs_1_1 : dp3 source reg combination oPos, oD0 is NOT allowed";
string VS_056 = 
	"vs_1_1 "
	"dp3 r0, oPos, oD0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_057_Criteria = { false, false, 0x0101, -1, -1, -1, -1, 0, -1, 0.f };
string VS_057_Desc = "vs_1_1 : dp3 source reg combination oPos, oT0 is NOT allowed";
string VS_057 = 
	"vs_1_1 "
	"dp3 r0, oPos, oT0 "
	"mov oPos, c0 ";

VS_CRITERIA VS_058_Criteria = { false, false, 0x0101, -1, -1, -1, -1, 0,