
/*++
Copyright (c) Microsoft Corporation

Module Name:

ESM_AutoGen.h

Abstract:

     This header file contains State Machines for USBHUB.
     This has been generated automatically from a visio file.
     DO NOT MODIFY THIS FILE MANUALLY.

--*/

#pragma once



//
// Enum of States in all the State Machines
//
typedef enum _ESM_STATE {
    EsmStateIgnored                                  = 1000,
    EsmStateEmptySubState                            = 1001,
    EsmStateNull                                     = 1002,
    EsmStateCompleteWithStatusFailed                 = 1003,
    EsmStateRequestPortCycle                         = 1004,
    EsmStateSignalQueryDeviceTextEvent               = 1005,
    EsmStateCompleteFDORequestWithStatusFailed       = 1006,
    EsmStateCompleteGetPortStatusWithInternalError   = 1007,
    EsmStateCompleteGetPortStatusWithNoSuchDevice    = 1008,
    EsmStateDisabled                                 = 2000,
    EsmStateAcknowledgingControllerResetComplete     = 2001,
    EsmStateAcknowledgingControllerResetCompleteInDisabled = 2002,
    EsmStateCheckingIfControllerHasKnownIssuesInDeliveringFSE = 2003,
    EsmStateCheckingIfEndpointCanBeResetAfterHalt    = 2004,
    EsmStateCheckingIfEndpointShouldBeAutoReset      = 2005,
    EsmStateCheckingIfEndpointShouldBeReconfiguredAfterStop = 2006,
    EsmStateCheckingIfEndpointShouldBeReconfiguredOnResetWhenNotHalted = 2007,
    EsmStateCheckingIfEndpointShouldBeStopped        = 2008,
    EsmStateCheckingIfIgnoreContextErrorOnEPStopFlagIsSet = 2009,
    EsmStateCheckingIfStopEndpointCommandShouldBeDelayed = 2010,
    EsmStateCheckingIfStopEndpontReissueCountReached = 2011,
    EsmStateCompletingClientResetRequest             = 2012,
    EsmStateCompletingClientResetRequestAfterEndpointReconfigure = 2013,
    EsmStateCompletingClientResetRequestAfterEndpointReconfigureFailure = 2014,
    EsmStateCompletingClientResetRequestAfterResetFailure = 2015,
    EsmStateCompletingClientResetRequestDueToOutstandingTransfers = 2016,
    EsmStateCompletingResetRequestWhenEndpointNotHalted = 2017,
    EsmStateControllerResetInEnabled                 = 2018,
    EsmStateDroppingFSEAfterStop                     = 2019,
    EsmStateEnabledAndMapping                        = 2020,
    EsmStateNotifyingTransferRingsEndpointHalted     = 2021,
    EsmStateNotifyingTransferRingsEndpointResetFromClient = 2022,
    EsmStateNotifyingTransferRingsFSEReceived        = 2023,
    EsmStateNotifyingTransferRingsOkToReclaimTransfersOnCancel = 2024,
    EsmStateNotifyingUCXAboutTransferCancellation    = 2025,
    EsmStateProcessingExpectedEventTRBsAfterEndpointHalt = 2026,
    EsmStateProcessingExpectedEventTRBsAfterEndpointStop = 2027,
    EsmStatePurgingTransferRingQueuesIfNeeded        = 2028,
    EsmStateReclaimingCanceledTransfersAfterControllerSurpriseRemoval = 2029,
    EsmStateReclaimingTransfersAfterControlEndpointAutoReset = 2030,
    EsmStateReclaimingTransfersAfterControllerReset  = 2031,
    EsmStateReclaimingTransfersAfterEndpointStop     = 2032,
    EsmStateReconfiguringEndpointAfterStop           = 2033,
    EsmStateReconfiguringEndpointOnReset             = 2034,
    EsmStateRequeuingPendingTransfersAfterHaltClear  = 2035,
    EsmStateResettingControlEndpoint                 = 2036,
    EsmStateResettingControllerDueToRepeatedStopEndpointFailure = 2037,
    EsmStateResettingEndpoint                        = 2038,
    EsmStateRestartingTransferRingQueuesIfNeeded     = 2039,
    EsmStateSimulatingEndpointHaltReceivedOnTimeout  = 2040,
    EsmStateSimulatingExpectedEventTRBsProcessedAfterHaltOnTimeout = 2041,
    EsmStateSimulatingExpectedEventTRBsProcessedOnTimeout = 2042,
    EsmStateSimulatingFSEReceivedOnTimeout           = 2043,
    EsmStateStartingMapping                          = 2044,
    EsmStateStoppingEndpoint                         = 2045,
    EsmStateStoppingMappingAfterControllerSurpriseRemovalInEnabled = 2046,
    EsmStateStoppingMappingBeforeEndpointReconfigure = 2047,
    EsmStateStoppingMappingOnCancelStart             = 2048,
    EsmStateStoppingMappingOnHalt                    = 2049,
    EsmStateUpdatingTransferRingDequeuePointers      = 2050,
    EsmStateWaitingForControllerResetCompletion      = 2051,
    EsmStateWaitingForControllerResetOrSurpriseRemovalNotification = 2052,
    EsmStateWaitingForEndpointDisable                = 2053,
    EsmStateWaitingForFSEAfterStopEndpointCommandCompletion = 2054,
    EsmStateWaitingForHaltedCompletionCode           = 2055,
    EsmStateWaitingForResetRequestFromClient         = 2056,
    EsmStateWaitingToReissueStopEndpointCommand1     = 2057,
    EsmStateWaitingToReissueStopEndpointCommand2     = 2058,
} ESM_STATE, *PESM_STATE;





//
// Enum of ETW state names
//
typedef enum _ESM_STATE_ETW {
    EsmStateEtwDisabled                              = 2000,
    EsmStateEtwAcknowledgingControllerResetComplete  = 85,
    EsmStateEtwAcknowledgingControllerResetCompleteInDisabled = 120,
    EsmStateEtwCheckingIfControllerHasKnownIssuesInDeliveringFSE = 113,
    EsmStateEtwCheckingIfEndpointCanBeResetAfterHalt = 66,
    EsmStateEtwCheckingIfEndpointShouldBeAutoReset   = 5,
    EsmStateEtwCheckingIfEndpointShouldBeReconfiguredAfterStop = 71,
    EsmStateEtwCheckingIfEndpointShouldBeReconfiguredOnResetWhenNotHalted = 59,
    EsmStateEtwCheckingIfEndpointShouldBeStopped     = 4,
    EsmStateEtwCheckingIfIgnoreContextErrorOnEPStopFlagIsSet = 73,
    EsmStateEtwCheckingIfStopEndpointCommandShouldBeDelayed = 74,
    EsmStateEtwCheckingIfStopEndpontReissueCountReached = 75,
    EsmStateEtwCompletingClientResetRequest          = 6,
    EsmStateEtwCompletingClientResetRequestAfterEndpointReconfigure = 61,
    EsmStateEtwCompletingClientResetRequestAfterEndpointReconfigureFailure = 62,
    EsmStateEtwCompletingClientResetRequestAfterResetFailure = 63,
    EsmStateEtwCompletingClientResetRequestDueToOutstandingTransfers = 67,
    EsmStateEtwCompletingResetRequestWhenEndpointNotHalted = 60,
    EsmStateEtwControllerResetInEnabled              = 87,
    EsmStateEtwDroppingFSEAfterStop                  = 110,
    EsmStateEtwEnabledAndMapping                     = 64,
    EsmStateEtwNotifyingTransferRingsEndpointHalted  = 51,
    EsmStateEtwNotifyingTransferRingsEndpointResetFromClient = 55,
    EsmStateEtwNotifyingTransferRingsFSEReceived     = 111,
    EsmStateEtwNotifyingTransferRingsOkToReclaimTransfersOnCancel = 118,
    EsmStateEtwNotifyingUCXAboutTransferCancellation = 38,
    EsmStateEtwProcessingExpectedEventTRBsAfterEndpointHalt = 114,
    EsmStateEtwProcessingExpectedEventTRBsAfterEndpointStop = 115,
    EsmStateEtwPurgingTransferRingQueuesIfNeeded     = 69,
    EsmStateEtwReclaimingCanceledTransfersAfterControllerSurpriseRemoval = 119,
    EsmStateEtwReclaimingTransfersAfterControlEndpointAutoReset = 93,
    EsmStateEtwReclaimingTransfersAfterControllerReset = 94,
    EsmStateEtwReclaimingTransfersAfterEndpointStop  = 96,
    EsmStateEtwReconfiguringEndpointAfterStop        = 72,
    EsmStateEtwReconfiguringEndpointOnReset          = 56,
    EsmStateEtwRequeuingPendingTransfersAfterHaltClear = 99,
    EsmStateEtwResettingControlEndpoint              = 41,
    EsmStateEtwResettingControllerDueToRepeatedStopEndpointFailure = 76,
    EsmStateEtwResettingEndpoint                     = 42,
    EsmStateEtwRestartingTransferRingQueuesIfNeeded  = 70,
    EsmStateEtwSimulatingEndpointHaltReceivedOnTimeout = 107,
    EsmStateEtwSimulatingExpectedEventTRBsProcessedAfterHaltOnTimeout = 116,
    EsmStateEtwSimulatingExpectedEventTRBsProcessedOnTimeout = 117,
    EsmStateEtwSimulatingFSEReceivedOnTimeout        = 106,
    EsmStateEtwStartingMapping                       = 65,
    EsmStateEtwStoppingEndpoint                      = 43,
    EsmStateEtwStoppingMappingAfterControllerSurpriseRemovalInEnabled = 97,
    EsmStateEtwStoppingMappingBeforeEndpointReconfigure = 58,
    EsmStateEtwStoppingMappingOnCancelStart          = 44,
    EsmStateEtwStoppingMappingOnHalt                 = 45,
    EsmStateEtwUpdatingTransferRingDequeuePointers   = 46,
    EsmStateEtwWaitingForControllerResetCompletion   = 90,
    EsmStateEtwWaitingForControllerResetOrSurpriseRemovalNotification = 112,
    EsmStateEtwWaitingForEndpointDisable             = 91,
    EsmStateEtwWaitingForFSEAfterStopEndpointCommandCompletion = 18,
    EsmStateEtwWaitingForHaltedCompletionCode        = 10,
    EsmStateEtwWaitingForResetRequestFromClient      = 12,
    EsmStateEtwWaitingToReissueStopEndpointCommand1  = 77,
    EsmStateEtwWaitingToReissueStopEndpointCommand2  = 78,
} ESM_STATE_ETW, *PESM_STATE_ETW;



//
// Definitions for State Entry Functions 
//
STATE_ENTRY_FUNCTION          ESM_AcknowledgingControllerResetComplete;

STATE_ENTRY_FUNCTION          ESM_AcknowledgingControllerResetCompleteInDisabled;

STATE_ENTRY_FUNCTION          ESM_CheckingIfControllerHasKnownIssuesInDeliveringFSE;

STATE_ENTRY_FUNCTION          ESM_CheckingIfEndpointCanBeResetAfterHalt;

STATE_ENTRY_FUNCTION          ESM_CheckingIfEndpointShouldBeAutoReset;

STATE_ENTRY_FUNCTION          ESM_CheckingIfEndpointShouldBeReconfiguredAfterStop;

STATE_ENTRY_FUNCTION          ESM_CheckingIfEndpointShouldBeReconfiguredOnResetWhenNotHalted;

STATE_ENTRY_FUNCTION          ESM_CheckingIfEndpointShouldBeStopped;

STATE_ENTRY_FUNCTION          ESM_CheckingIfIgnoreContextErrorOnEPStopFlagIsSet;

STATE_ENTRY_FUNCTION          ESM_CheckingIfStopEndpointCommandShouldBeDelayed;

STATE_ENTRY_FUNCTION          ESM_CheckingIfStopEndpontReissueCountReached;

STATE_ENTRY_FUNCTION          ESM_CompletingClientResetRequest;

STATE_ENTRY_FUNCTION          ESM_CompletingClientResetRequestAfterEndpointReconfigure;

STATE_ENTRY_FUNCTION          ESM_CompletingClientResetRequestAfterEndpointReconfigureFailure;

STATE_ENTRY_FUNCTION          ESM_CompletingClientResetRequestAfterResetFailure;

STATE_ENTRY_FUNCTION          ESM_CompletingClientResetRequestDueToOutstandingTransfers;

STATE_ENTRY_FUNCTION          ESM_CompletingResetRequestWhenEndpointNotHalted;

STATE_ENTRY_FUNCTION          ESM_ControllerResetInEnabled;

STATE_ENTRY_FUNCTION          ESM_Disabled;

STATE_ENTRY_FUNCTION          ESM_DroppingFSEAfterStop;

STATE_ENTRY_FUNCTION          ESM_EnabledAndMapping;

STATE_ENTRY_FUNCTION          ESM_NotifyingTransferRingsEndpointHalted;

STATE_ENTRY_FUNCTION          ESM_NotifyingTransferRingsEndpointResetFromClient;

STATE_ENTRY_FUNCTION          ESM_NotifyingTransferRingsFSEReceived;

STATE_ENTRY_FUNCTION          ESM_NotifyingTransferRingsOkToReclaimTransfersOnCancel;

STATE_ENTRY_FUNCTION          ESM_NotifyingUCXAboutTransferCancellation;

STATE_ENTRY_FUNCTION          ESM_ProcessingExpectedEventTRBsAfterEndpointHalt;

STATE_ENTRY_FUNCTION          ESM_ProcessingExpectedEventTRBsAfterEndpointStop;

STATE_ENTRY_FUNCTION          ESM_PurgingTransferRingQueuesIfNeeded;

STATE_ENTRY_FUNCTION          ESM_ReclaimingCanceledTransfersAfterControllerSurpriseRemoval;

STATE_ENTRY_FUNCTION          ESM_ReclaimingTransfersAfterControlEndpointAutoReset;

STATE_ENTRY_FUNCTION          ESM_ReclaimingTransfersAfterControllerReset;

STATE_ENTRY_FUNCTION          ESM_ReclaimingTransfersAfterEndpointStop;

STATE_ENTRY_FUNCTION          ESM_ReconfiguringEndpointAfterStop;

STATE_ENTRY_FUNCTION          ESM_ReconfiguringEndpointOnReset;

STATE_ENTRY_FUNCTION          ESM_RequeuingPendingTransfersAfterHaltClear;

STATE_ENTRY_FUNCTION          ESM_ResettingControlEndpoint;

STATE_ENTRY_FUNCTION          ESM_ResettingControllerDueToRepeatedStopEndpointFailure;

STATE_ENTRY_FUNCTION          ESM_ResettingEndpoint;

STATE_ENTRY_FUNCTION          ESM_RestartingTransferRingQueuesIfNeeded;

STATE_ENTRY_FUNCTION          ESM_SimulatingEndpointHaltReceivedOnTimeout;

STATE_ENTRY_FUNCTION          ESM_SimulatingExpectedEventTRBsProcessedAfterHaltOnTimeout;

STATE_ENTRY_FUNCTION          ESM_SimulatingExpectedEventTRBsProcessedOnTimeout;

STATE_ENTRY_FUNCTION          ESM_SimulatingFSEReceivedOnTimeout;

STATE_ENTRY_FUNCTION          ESM_StartingMapping;

STATE_ENTRY_FUNCTION          ESM_StoppingEndpoint;

STATE_ENTRY_FUNCTION          ESM_StoppingMappingAfterControllerSurpriseRemovalInEnabled;

STATE_ENTRY_FUNCTION          ESM_StoppingMappingBeforeEndpointReconfigure;

STATE_ENTRY_FUNCTION          ESM_StoppingMappingOnCancelStart;

STATE_ENTRY_FUNCTION          ESM_StoppingMappingOnHalt;

STATE_ENTRY_FUNCTION          ESM_UpdatingTransferRingDequeuePointers;

STATE_ENTRY_FUNCTION          ESM_WaitingForControllerResetCompletion;

STATE_ENTRY_FUNCTION          ESM_WaitingForControllerResetOrSurpriseRemovalNotification;

STATE_ENTRY_FUNCTION          ESM_WaitingForEndpointDisable;

STATE_ENTRY_FUNCTION          ESM_WaitingForFSEAfterStopEndpointCommandCompletion;

STATE_ENTRY_FUNCTION          ESM_WaitingForHaltedCompletionCode;

STATE_ENTRY_FUNCTION          ESM_WaitingForResetRequestFromClient;

STATE_ENTRY_FUNCTION          ESM_WaitingToReissueStopEndpointCommand1;

STATE_ENTRY_FUNCTION          ESM_WaitingToReissueStopEndpointCommand2;




//
// Sub State Entries for the states in the State Machine
//


//
// State Entries for the states in the State Machine
//
STATE_ENTRY   EsmStateEntryAcknowledgingControllerResetComplete = {
    // State ETW Name
    EsmStateEtwAcknowledgingControllerResetComplete,
    // State Entry Function
    ESM_AcknowledgingControllerResetComplete,
    // State Flags
    StateFlagNone,
    // Sub State Machine Information
    NULL,
    // Event State Pairs for Transitions
    {
        { EsmEventOperationSuccess ,    EsmStateWaitingForEndpointDisable },
        { EsmEventNull ,                EsmStateNull },
    }
};



STATE_ENTRY   EsmStateEntryAcknowledgingControllerResetCompleteInDisabled = {
    // State ETW Name
    EsmStateEtwAcknowledgingControllerResetCompleteInDisabled,
    // State Entry Function
    ESM_AcknowledgingControllerResetCompleteInDisabled,
    // State Flags
    StateFlagNone,
    // Sub State Machine Information
    NULL,
    // Event State Pairs for Transitions
    {
        { EsmEventOperationSuccess ,    EsmStateDisabled },
        { EsmEventNull ,                EsmStateNull },
    }
};



STATE_ENTRY   EsmStateEntryCheckingIfControllerHasKnownIssuesInDeliveringFSE = {
    // State ETW Name
    EsmStateEtwCheckingIfControllerHasKnownIssuesInDeliveringFSE,
    // State Entry Function
    ESM_CheckingIfControllerHasKnownIssuesInDeliveringFSE,
    // State Flags
    StateFlagNone,
    // Sub State Machine Information
    NULL,
    // Event State Pairs for Transitions
    {
        { EsmEventYes ,                 EsmStateDroppingFSEAfterStop },
        { EsmEventNo ,                  EsmStateWaitingForFSEAfterStopEndpointCommandCompletion },
        { EsmEventNull ,                EsmStateNull },
    }
};



STATE_ENTRY   EsmStateEntryCheckingIfEndpointCanBeResetAfterHalt = {
    // State ETW Name
    EsmStateEtwCheckingIfEndpointCanBeResetAfterHalt,
    // State Entry Function
    ESM_CheckingIfEndpointCanBeResetAfterHalt,
    // State Flags
    StateFlagNone,
    // Sub State Machine Information
    NULL,
    // Event State Pairs for Transitions
    {
        { EsmEventYes ,                 EsmStateResettingEndpoint },
        { EsmEventNo ,                  EsmStateCompletingClientResetRequestDueToOutstandingTransfers },
        { EsmEventNull ,                EsmStateNull },
    }
};



STATE_ENTRY   EsmStateEntryCheckingIfEndpointShouldBeAutoReset = {
    // State ETW Name
    EsmStateEtwCheckingIfEndpointShouldBeAutoReset,
    // State Entry Function
    ESM_CheckingIfEndpointShouldBeAutoReset,
    // State Flags
    StateFlagNone,
    // Sub State Machine Information
    NULL,
    // Event State Pairs for Transitions
    {
        { EsmEventYes ,                 EsmStateResettingControlEndpoint },
        { EsmEventNo ,                  EsmStateProcessingExpectedEventTRBsAfterEndpointHalt },
        { EsmEventNull ,                EsmStateNull },
    }
};



STATE_ENTRY   EsmStateEntryCheckingIfEndpointShouldBeReconfiguredAfterStop = {
    // State ETW Name
    EsmStateEtwCheckingIfEndpointShouldBeReconfiguredAfterStop,
    // State Entry Function
    ESM_CheckingIfEndpointShouldBeReconfiguredAfterStop,
    // State Flags
    StateFlagNone,
    // Sub State Machine Information
    NULL,
    // Event State Pairs for Transitions
    {
        { EsmEventYes ,                 EsmStateReconfiguringEndpointAfterStop },
        { EsmEventNo ,                  EsmStateUpdatingTransferRingDequeuePointers },
        { EsmEventNull ,                EsmStateNull },
    }
};



STATE_ENTRY   EsmStateEntryCheckingIfEndpointShouldBeReconfiguredOnResetWhenNotHalted = {
    // State ETW Name
    EsmStateEtwCheckingIfEndpointShouldBeReconfiguredOnResetWhenNotHalted,
    // State Entry Function
    ESM_CheckingIfEndpointShouldBeReconfiguredOnResetWhenNotHalted,
    // State Flags
    StateFlagNone,
    // Sub State Machine Information
    NULL,
    // Event State Pairs for Transitions
    {
        { EsmEventYes ,                 EsmStateStoppingMappingBeforeEndpointReconfigure },
        { EsmEventNo ,                  EsmStateCompletingResetRequestWhenEndpointNotHalted },
        { EsmEventNull ,                EsmStateNull },
    }
};



STATE_ENTRY   EsmStateEntryCheckingIfEndpointShouldBeStopped = {
    // State ETW Name
    EsmStateEtwCheckingIfEndpointShouldBeStopped,
    // State Entry Function
    ESM_CheckingIfEndpointShouldBeStopped,
    // State Flags
    StateFlagNone,
    // Sub State Machine Information
    NULL,
    // Event State Pairs for Transitions
    {
        { EsmEventYes ,                 EsmStateCheckingIfStopEndpointCommandShouldBeDelayed },
        { EsmEventNo ,                  EsmStateReclaimingTransfersAfterEndpointStop },
        { EsmEventNull ,                EsmStateNull },
    }
};



STATE_ENTRY   EsmStateEntryCheckingIfIgnoreContextErrorOnEPStopFlagIsSet = {
    // State ETW Name
    EsmStateEtwCheckingIfIgnoreContextErrorOnEPStopFlagIsSet,
    // State Entry Function
    ESM_CheckingIfIgnoreContextErrorOnEPStopFlagIsSet,
    // State Flags
    StateFlagNone,
    // Sub State Machine Information
    NULL,
    // Event State Pairs for Transitions
    {
        { EsmEventYes ,                 EsmStateCheckingIfControllerHasKnownIssuesInDeliveringFSE },
        { EsmEventNo ,                  EsmStateResettingControllerDueToRepeatedStopEndpointFailure },
        { EsmEventNull ,                EsmStateNull },
    }
};



STATE_ENTRY   EsmStateEntryCheckingIfStopEndpointCommandShouldBeDelayed = {
    // State ETW Name
    EsmStateEtwCheckingIfStopEndpointCommandShouldBeDelayed,
    // State Entry Function
    ESM_CheckingIfStopEndpointCommandShouldBeDelayed,
    // State Flags
    StateFlagNone,
    // Sub State Machine Information
    NULL,
    // Event State Pairs for Transitions
    {
        { EsmEventYes ,                 EsmStateWaitingToReissueStopEndpointCommand2 },
        { EsmEventNo ,                  EsmStateStoppingEndpoint },
        { EsmEventNull ,                EsmStateNull },
    }
};



STATE_ENTRY   EsmStateEntryCheckingIfStopEndpontReissueCountReached = {
    // State ETW Name
    EsmStateEtwCheckingIfStopEndpontReissueCountReached,
    // State Entry Function
    ESM_CheckingIfStopEndpontReissueCountReached,
    // State Flags
    StateFlagNone,
    // Sub State Machine Information
    NULL,
    // Event State Pairs for Transitions
    {
        { EsmEventYes ,                 EsmStateCheckingIfIgnoreContextErrorOnEPStopFlagIsSet },
        { EsmEventNo ,                  EsmStateStoppingEndpoint },
        { EsmEventNull ,                EsmStateNull },
    }
};



STATE_ENTRY   EsmStateEntryCompletingClientResetRequest = {
    // State ETW Name
    EsmStateEtwCompletingClientResetRequest,
    // State Entry Function
    ESM_CompletingClientResetRequest,
    // State Flags
    StateFlagNone,
    // Sub State Machine Information
    NULL,
    // Event State Pairs for Transitions
    {
        { EsmEventOperationSuccess ,    EsmStateStartingMapping },
        { EsmEventNull ,                EsmState